import { Action } from '@ngrx/store';
import { User } from 'src/app/shared/models/user.model';

//type of actions
export enum UserActionType {
  /* action: get all users */
  GET_ALL_USERS = '[User] GET ALL USERS',
  GET_ALL_USERS_SUCCESS = '[User] GET-ALL USERS SUCCESS',
  GET_ALL_USERS_ERROR = '[User] GET-ALL USERS ERROR',

  /* action: search a user */

  SEARCH_A_USER = '[User] SEARCH A USER',
  SEARCH_A_USER_SUCCESS = '[User] SEARCH A USER SUCCESS',
  SEARCH_A_USER_ERROR = '[User] SEARCH A USER ERROR',
}

//create actions

export class GetAllUsersAction implements Action {
  type: UserActionType = UserActionType.GET_ALL_USERS;

  constructor(public payload: any) {}
}

export class GetAllUsersActionSuccess implements Action {
  type: UserActionType = UserActionType.GET_ALL_USERS_SUCCESS;
  constructor(public payload: User[]) {}
}

export class GetAllUsersActionError implements Action {
  type: UserActionType = UserActionType.GET_ALL_USERS_ERROR;
  constructor(public payload: string) {}
}

/* Actios nof searching a user */

export class SearchUsersAction implements Action {
  type: UserActionType = UserActionType.SEARCH_A_USER;

  constructor(public payload: any) {}
}

export class SearchUserActionSuccess implements Action {
  type: UserActionType = UserActionType.SEARCH_A_USER_SUCCESS;
  constructor(public payload: User[]) {}
}

export class SearchUserActionError implements Action {
  type: UserActionType = UserActionType.SEARCH_A_USER_ERROR;
  constructor(public payload: string) {}
}

export type UserAction =
  | GetAllUsersAction
  | GetAllUsersActionSuccess
  | GetAllUsersActionError
  | SearchUsersAction
  | SearchUserActionSuccess
  | SearchUserActionError;
