import { userReducer } from 'src/app/ngrx/users/users.reducer';
import { UserState, UserStateEnum } from './../../../ngrx/users/users.reducer';
import { Observable, map } from 'rxjs';
import { Component, OnInit } from '@angular/core';
import { Store } from '@ngrx/store';

@Component({
  selector: 'app-users-management',
  templateUrl: './users-management.component.html',
  styleUrls: ['./users-management.component.css']
})
export class UsersManagementComponent implements OnInit {

  userState$ !: Observable<UserState>
  readonly userStateEnum = UserStateEnum

  constructor(private store: Store<any>) { }

  ngOnInit(): void {

  this.userState$ = this.store.pipe(

    map( (state) => state.userReducer)
  )
  }

}
